//Заголовочные файлы
//***************************************************************
//библиотека настроек и подпрограмм
#include "chasis.h"

//Глобальные переменные
//***************************************************************
const char MainSpeed = 2 ; //скорость движения 
const int TurningDelayTime = 30; //скорость поворота

//Настройки
//***************************************************************
void setup()
{
  //задержка перед стартом
  delay (3000);
  //инициализация всех настроек
  initialization();
}

//Главная программа
//===============================================================
void loop()
{
  //если сработал передний датчик, то
  //на все колеса установить основную скорость
  if (digitalRead (Line_Detector_F) == 1)
  {
    for (byte i = 0; i < 4; i++)
    {
      MoveFlags[i] = MainSpeed;
    }
  }

  //пока передний датчик за пределами линии...
  while (digitalRead (Line_Detector_F) == 0)
  {
    char counter = MainSpeed;
    //если сработал  левый, то увеличить скорость справа и уменьшить слева
    if (digitalRead(Line_Detector_L) == 1)
    {
      //изменять пока не сработает передний датчик
      while (digitalRead (Line_Detector_F) == 0)
      {
        if (abs(counter) > MainSpeed)
        {
          delay(TurningDelayTime);
        }
        else
        {
          counter--;
          delay(TurningDelayTime);
        }
        MoveFlags[0] = counter;
        MoveFlags[1] = counter;
      }
    }
    //если сработал  правый, то увеличить скорость слева и уменьшить справа
    if (digitalRead (Line_Detector_R) == 1)
    {
      //изменять пока не сработает передний датчик
      while (digitalRead (Line_Detector_F) == 0)
      {
        if (abs(counter) > MainSpeed)
        {
          delay(TurningDelayTime);
        }
        else
        {
          counter--;
          delay(TurningDelayTime);
        }
        MoveFlags[2] = counter;
        MoveFlags[3] = counter;
      }
    }

    // при срабатывании левого и правого датчика, уменьшаем скорость до единицы
    if ((digitalRead(Line_Detector_L) == 1) and (digitalRead (Line_Detector_R) == 1))
    {
      for (byte i = 0; i < 4; i++)
      {
        MoveFlags[i] = 1;
      }
    }
    
  }
}

