//библеотека обработки прерываний таймера(ШИМ)
#include "TimerOne.h"

//Переименования
//***************************************************************
#define FRONT_LEFT_A  3
#define FRONT_LEFT_B  2
#define FRONT_RIGHT_A 8
#define FRONT_RIGHT_B 9
#define REAR_LEFT_A   4
#define REAR_LEFT_B   5
#define REAR_RIGHT_A  7
#define REAR_RIGHT_B  6

#define FORWARD       12
#define BACKWARD      -12
#define STOP          0

#define Line_Detector_F    12
#define Line_Detector_L    19
#define Line_Detector_R    11
#define Line_Detector_B    18

//#define VEL_PIN_1     14
//#define VEL_PIN_2     15
//#define VEL_PIN_3     16
//#define VEL_PIN_4     17

//Глобальные переменные
//***************************************************************
//счетчик ШИМ
byte interrupt_counter = 0;

//матрица выводов драйвера
byte PimMap[4][2] =
{
  {FRONT_LEFT_A,  FRONT_LEFT_B },
  {REAR_LEFT_A,   REAR_LEFT_B  },
  {FRONT_RIGHT_A, FRONT_RIGHT_B},
  {REAR_RIGHT_A,  REAR_RIGHT_B }
};

//матрица скоростей колёс от -12 до +12
signed int MoveFlags[4] = {STOP, STOP, STOP, STOP};

//Подпрограммы
//---------------------------------------------------------------

//мигание индикаторным  светодиодом 
void leds_blink()
{
  digitalWrite (0, LOW);
  digitalWrite (1, LOW);
  delayMicroseconds(100);
  digitalWrite (1, HIGH);
  digitalWrite (0, HIGH);
};

//управление скоростью вращения в прерывании(ШИМ)
void WeelStateFunction()
{
  //уровень ШИМа при движении вперед
  for (byte i = 0; i < 4; i++)
  {
    if (MoveFlags[i] > 0)
    {
      if (MoveFlags[i] > interrupt_counter)
      {
        digitalWrite (PimMap[i][0], HIGH);
        digitalWrite (PimMap[i][1], LOW);
      }
      if (MoveFlags[i] < interrupt_counter)
      {
        digitalWrite (PimMap[i][0], HIGH);
        digitalWrite (PimMap[i][1], HIGH);
      };
    }
    //уровень ШИМа при движении назад
    if (MoveFlags[i] < 0)
    {
       if (MoveFlags[i]*(-1) > interrupt_counter)
      {
        digitalWrite (PimMap[i][0], LOW);
        digitalWrite (PimMap[i][1], HIGH);
      }
      if (MoveFlags[i]*(-1) < interrupt_counter)
      {
        digitalWrite (PimMap[i][0], HIGH);
        digitalWrite (PimMap[i][1], HIGH);
      };
    }
  };
  //ограничение максимальной скорости и счетчик разрядов ШИМ
  interrupt_counter++;
  if (interrupt_counter == 12) interrupt_counter = 0;
};

void initialization ()
{
  //инициализация портов ввода/вывода
  for (int i = 0; i < 10; i++) pinMode (i, HIGH);
  for (int i = 0; i < 10; i++) digitalWrite (i, HIGH);
  //инициализация прерываний с частотой 800 микросекунд
  Timer1.initialize(800);
  //обработка функции WeelStateFunction в прерывании
  Timer1.attachInterrupt(WeelStateFunction);
  //Инициализация прошла успешно
  leds_blink();
}


